                  /*--.          .-"-.
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Author's note:  |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "Set.h"

struct Var {
	char *name;
	int nameLen;
	char *value;
	int valueLen;
};

class Config {
private:
	Set <Var> vars;
public:
	Config();
	~Config();

	void clear();
	bool loadFromFile(const char *fileName);
	bool writeToFile(const char *fileName);

	bool find(const char *name, int *index = NULL);
	bool remove(const char *name);

	bool getBool(const char *name, bool &value);
	bool getInt(const char *name, int &value);
	char *getString(const char *name);

	void setBool(const char *name, bool value);
	void setInt(const char *name, int value);
	void setString(const char *name, char *value);
};


#endif // _CONFIG_H_
