                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Author's note:  |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/

#ifndef _PROCEDURALTERRAIN_H_
#define _PROCEDURALTERRAIN_H_

#include "../Renderer.h"
#include "../Math/Vertex.h"
#include "OrderedSet.h"
#include "Fifo.h"

typedef float (* ProceduralTerrainFunc)(const float x, const float z);

struct Block;

class OptVertexBufferFactory;

class ProceduralTerrain {
protected:
	ProceduralTerrainFunc terrainFunc;
	//OrderedSet <Block> blocks;
	Set <Block *> blocks;
	//Fifo <Block> blockQueue;
	int maxBlocks;
	Set <unsigned int *> indices;
	float blockSize;
	int blockDensity;
	int texRepeat;

	void setBlock(Block *block);
	void freeBlock(const Block *block);

public:
	ProceduralTerrain(ProceduralTerrainFunc terrFunc, float bSize, int bDensity, int blockTexRepeat, int mBlocks);
	~ProceduralTerrain();

	float blockDistance(const int x, const int z, const Vertex &pos);
	int draw(Renderer *renderer, const Vertex &pos, float viewDistance, float lodFactor);

	OptVertexBufferFactory& m_factory;
};

#endif // _PROCEDURALTERRAIN_H_
